



struct ID{ 
       int id;
       char name[32];
       double **lsm;
       };


struct DATA{ 
       double *Eigenvalue;
       double **Eigenvector;
};


  /**********************************************************************/  
  
 int ** CreateTwoDimensionalArray ( unsigned int  uiYsize, unsigned int uiXsize)
{
      int  **ppiHead = NULL;   
      
      unsigned int  uiYindex = 0;   
    
      ppiHead = (int **)malloc(uiYsize*sizeof(int *));  

      for(uiYindex = 0; uiYindex < uiYsize;uiYindex++) 
     {
          *(ppiHead + uiYindex) = (int *) malloc(uiXsize*sizeof(int)); 
     }
     return  ppiHead;   
}

  /**********************************************************************/  
  
double ** d_CreateTwoDimensionalArray ( unsigned int  uiYsize,unsigned  int uiXsize)
{
      double  **ppiHead = NULL;   
      
      unsigned int  uiYindex = 0;   
    
      ppiHead = (double **)malloc(uiYsize*sizeof(double *));  

      for(uiYindex = 0; uiYindex < uiYsize;uiYindex++) 
     {
          *(ppiHead + uiYindex) = (double *) malloc(uiXsize*sizeof(double)); 
     }
     return  ppiHead;   
}


  /**********************************************************************/  
  
  
void DeleteTwoDimensionalArray(int **ppiHead, int  uiYsize,  int uiXsize)
{
       int uiYindex;
    
      for(uiYindex = 0;uiYindex < uiYsize;uiYindex++)
     {
          free(*(ppiHead + uiYindex));  
     }
}


  /**********************************************************************/  
  
  
 double *CreateONEDimensionalArray ( unsigned int  uisize){
        double  *piHead = NULL;
        piHead = (double *) malloc(uisize*sizeof(double));
      
        return  piHead;

}
 
 
  /**********************************************************************/  

 double **AVG_matrix_x(int **a,int pixel,int P_NO){
       int i=0,j=0;
       double **b = NULL,avg_x=0.0;
      
       b = d_CreateTwoDimensionalArray(P_NO,pixel);
       
       for(j=0;j<P_NO;j++)for(i=0;i<pixel;i++)b[j][i]=0.0;
       for(j=0;j<P_NO;j++){
              avg_x=0.0;             
             for(i=0;i<pixel;i++)
                          avg_x+=(double)a[j][i]/pixel;
             for(i=0;i<pixel;i++) 
                                  b[j][i]=(double)a[j][i]-avg_x;
              }
      
       return b;
       }
  
  
    /**********************************************************************/  
    
    
         
 double *AVG_matrix_y(double **a,int pixel,int P_NO){
       int i=0,j=0;
       double *b = NULL;
      
      b = CreateONEDimensionalArray(pixel);
       
       for(i=0;i<pixel;i++)b[i]=0.0;
       
       for(i=0;i<pixel;i++){
                     
                      for(j=0;j<P_NO;j++)
                                         b[i]+=a[j][i]/P_NO;
                      
       }
       return b;
       }


  /**********************************************************************/  


 int **transposed_matrix( int **a,int pixel,int P_NO){
       int i=0, j=0;
	int temp;
        int **b = NULL;

	b = CreateTwoDimensionalArray(pixel,P_NO); 

for(j=0;j<pixel;j++)  for(i=0;i<P_NO;i++)  b[j][i]=a[i][j];
   return b;            
      
       }

  /**********************************************************************/  
  
  
double **d_transposed_matrix( double **a,int pixel,int P_NO){
int i=0, j=0;
	int temp;
        double **b = NULL;

	b = d_CreateTwoDimensionalArray(pixel,P_NO); 

for(j=0;j<pixel;j++)  for(i=0;i<P_NO;i++)  b[j][i]=a[i][j];
   return b;            
      
       }
  /**********************************************************************/  
  
  
double **Autocorrelation_matrix( int **a, int **b,int pixel,int P_NO){
       int i=0,j=0,k=0;
       double **c=NULL;
       c=d_CreateTwoDimensionalArray(P_NO,P_NO); 
       for(i=0;i<P_NO;i++)
                          for(j=0;j<P_NO;j++) c[i][j]=0.0;
       for(i=0;i<P_NO;i++)
                          for(j=0;j<P_NO;j++)
                                             for(k=0;k<pixel;k++) c[i][j]+=(double)(a[i][k]*b[k][j])/P_NO;
                                                             
                                                                  
       return c;                           
       }                    


  /**********************************************************************/  
  
  
double **multiplication( double **a, double **b,int pixel,int P_NO){
       int i=0,j=0,k=0;
       double **c=NULL;
       c=d_CreateTwoDimensionalArray(P_NO,P_NO); 
       for(i=0;i<P_NO;i++)
                          for(j=0;j<P_NO;j++) c[i][j]=0.0;
       for(i=0;i<P_NO;i++)
                          for(j=0;j<P_NO;j++)
                                             for(k=0;k<pixel;k++) c[i][j]+=a[i][k]*b[k][j];
                                                             
                                                                  
       return c;                           
       }                    


  /**********************************************************************/  

double **eigenface(struct DATA d,int **b,int pixel,int P_NO){
       int i,j,k;
       double **c=NULL;
       c=d_CreateTwoDimensionalArray(P_NO,pixel);
       d.Eigenvector=d_transposed_matrix(d.Eigenvector,P_NO,P_NO);
      for(i=0;i<P_NO;i++)
                          for(j=0;j<pixel;j++) c[i][j]=0;
     
       for(i=0;i<P_NO;i++){
                             for(j=0;j<pixel;j++){
                                             for(k=0;k<P_NO;k++) c[i][j]+=(double)(d.Eigenvector[i][k]*b[k][j])/(sqrt(d.Eigenvalue[i]));
                                             }
                          }
       
       return c;
       }


  /**********************************************************************/  


double similarity(double **a,int *b,int pixel,int NO){
       int i,j;
       double c=0.0;
      // c=CreateONEDimensionalArray(pixel);
       //for(j=0;j<pixel;j++)   c[j]=0.0;
      for(i=0;i<NO;i++){
      for(j=0;j<pixel;j++)   c+=(double)(a[i][j]*b[j]);
      printf("%f ",c);
      }
      printf("\n");
      c=c/pixel;
      return c;
                    
       }

   /**********************************************************************/  
   
/*double *lagrange(int *y,int pixel){
        int i,j;
        double *b=NULL,*x=NULL,double yy=0.0;
        b=d_CreateONEDimensionalArray(pixel);
        x=d_CreateONEDimensionalArray(pixel);  
        for(i=0;i<pixel;i++) x[i]=(doble)i;
        for(i=0;i<=n-1;i++){ 
                           b[i]=y[i];
                           for(j=0;j<=pixel-1;j++)
                                              if(j!=i) a[i]*=(xx-x[j])/(x[i]-x[j]);
                           yy+=a[i];
                           }
   
   */
   
   
   
   
  /**********************************************************************/  
  

struct DATA Jacobi(double **A,int n,int pixel,struct DATA d)
{
       
         
  double  **Q=NULL,**QT=NULL,*temp;
  
  double eps=1.0e-6, max=0.0,TAN2=0.0,SIN=0.0,SIN2=0.0,COS=0.0,COS2=0.0,Theta=0.0,s;
  int i, j,ct=0,I,J,k,p,q,t;
			
	
	
	d.Eigenvector = d_CreateTwoDimensionalArray(n,n);
	d.Eigenvalue = CreateONEDimensionalArray(n);
    Q = d_CreateTwoDimensionalArray(n,n);
	QT = d_CreateTwoDimensionalArray(n,n);
	temp=CreateONEDimensionalArray(n);
for(i=0;i<n;i++){
		 for(j=0;j<n;j++){
				           d.Eigenvector[i][j]=0.0;
		                 }
                         d.Eigenvector[i][i]=1.0;
	}
	
	
	while(ct<1000){
                
               
                
                for(i=0;i<n;i++){
		        for(j=0;j<n;j++){
				           Q[i][j]=0.0;
		                 }
                         Q[i][i]=1.0;
	}
		           //printf("%d\n",ct);
		           max=0.0;
                   for(i=0;i<n;i++){
		                            for(j=0;j<n;j++){
			                                         if(j!=i){
				                                              if(fabs(A[i][j])>max){
					                                                                max=fabs(A[i][j]);
                                                                                    I=i;
					                                                                J=j;
					                                                                
                                                                                    }
                                                              }
                                                    }
                                   }
                   if(A[I][I]-A[J][J]==0){
                                                            printf("The input picture has redundant,Please input the different picture.");
                                                            exit(0); 
                                                            }

    	
		
                  if(max<eps){
                                for(k=0;k<n;k++){
                                                 d.Eigenvalue[k]=A[k][k];
			                                     }
                               d.Eigenvector=d_transposed_matrix(d.Eigenvector,n,n);
                                for(i=0;i<n;i++)
                                                {
                                                p=i;q=d.Eigenvalue[i];
                                                for(j=i+1;j<10;j++)
                                                if(q<d.Eigenvalue[j]){p=j;q=d.Eigenvalue[j];}
                                                if(i!=p)
                                                {s=d.Eigenvalue[i];
                                                temp=d.Eigenvector[i];
                                                d.Eigenvalue[i]=d.Eigenvalue[p];
                                                d.Eigenvector[i]=d.Eigenvector[p];
                                                d.Eigenvalue[p]=s;
                                                d.Eigenvector[p]=temp;
                                               }
         
                                                }
                                d.Eigenvector=d_transposed_matrix(d.Eigenvector,n,n);
                              
                                ct=1000;
                               
                               /*         printf("///////////////////////\n");
			                           for(k=0;k<n;k++){for(t=0;t<n;t++)printf("%f ",A[k][t]);printf("\n");}
                                      printf("///////////////////////\n");
                                      for(t=0;t<n;t++)printf("%f ",d.Eigenvalue[t]);
                                      printf("\n");
                                       printf("*******************\n");
                                      for(k=0;k<n;k++){for(t=0;t<n;t++)printf("%f ",d.Eigenvector[k][t]);printf("\n");}
                                */
                                return d;	 			

		                        }
		
                   else if(max>=eps){
			                         
			                           TAN2=-(2*A[I][J]/(A[I][I]-A[J][J]));
			                           COS2=1/sqrt(1+TAN2*TAN2);
			                           SIN2=TAN2/sqrt(1+TAN2*TAN2);
			                           COS=sqrt((1+COS2)/2);
			                           SIN=SIN2/(2*COS);
			                           Theta=asin(SIN);
                                       
                                       if(fabs(Theta)<=M_PI/4){
                                       //printf("COS=%f SIN=%f\n",COS,SIN);
			                           Q[I][I]=COS;
			                           Q[I][J]=SIN;
			                           Q[J][I]=-SIN;
			                           Q[J][J]=COS;
			                          // printf("\n");
			                          // for(k=0;k<n;k++){for(t=0;t<n;t++)printf("%f ",Q[k][t]);printf("\n");}
			                           QT=d_transposed_matrix(Q,n,n);
			                          // printf("*******************\n");
			                         // for(k=0;k<n;k++){for(t=0;t<n;t++)printf("%f ",QT[k][t]);printf("\n");}
			                           A=multiplication(QT,A,n,n);
			                           A=multiplication(A,Q,n,n);
			                           d.Eigenvector=multiplication(d.Eigenvector,Q,n,n);
			                          // printf("///////////////////////\n");
			                          // for(k=0;k<n;k++){for(t=0;t<n;t++)printf("%f ",A[k][t]);printf("\n");}
                                      // printf("*******************\n");
                                      // for(k=0;k<n;k++){for(t=0;t<n;t++)printf("%f ",d.Eigenvector[k][t]);printf("\n");}
                                       }
                       }
                  ct++;
                  }
}

/**********************************************************************/  
  
  
  
  
  
  
#define N 50
double **sort(int k, double **data);
double cal(int t,int line,double *out,double **data);
double d_pow(double ival,int t);



double *LSM(double *read,int pixel){
    int iHeight,iWidth,iMaxValue,i,j,k,line;
    double *x,*y,*out,**data,m,ival,t,s=0.0,*out5;
/***********************************************************/    
    
    
    x=CreateONEDimensionalArray(pixel);
    y=CreateONEDimensionalArray(pixel);
    data=d_CreateTwoDimensionalArray(N+1,N+1);
    out=CreateONEDimensionalArray(N);
    out5= CreateONEDimensionalArray(5);
    for(i=0;i<pixel;i++){
                         x[i]=(double)i;
                         y[i]=(double)read[i];
                         }
 /***********************************************************/    
    data[0][0]=pixel;
    for (i=1;i<N;i++) {
        t=0.0;
        s=0.0;
        for (j=0;j<pixel;j++){
            s=d_pow(x[j],2*i);
            t+=s;
            }
        data[i][i]=t;
    }
     
     for (i=0;i<N-1;i++) {
        for (j=i+1;j<N;j++) {
            t=0.0;
            s=0.0;
            for (k=0;k<pixel;k++){
            s=d_pow(x[k],i+j);
            t+=s;}
            data[i][j]=t;
            data[j][i]=t;
        }
}
for (i=0;i<N;i++) {
        t=0.0;
        s=0.0;
        for (j=0;j<pixel;++j){
            s=d_pow(x[j],i);
            t+=s*y[j];}
        data[i][N]=t;
    }
    
    
/***********************************************************/
 for (k=0;k<N-1;k++){
        for (i=k+1;i<N;i++){
            data=sort(k,data);             
            if(!data[k][k]) continue;        
            m=data[i][k]/data[k][k];    
            for (j=k;j<N+1;j++) {
                data[i][j]=data[i][j]-m*data[k][j];
            }
        } 
 }
  for (i=0;i<N;i++){
        out[N-1-i]=(data[N-1-i][N]-cal(i,N-1-i,out,data))/data[N-1-i][N-1-i];
        
}
 for (i=0;i<5;i++) {out5[i]=out[i];printf("%f ",out5[i]);}

 printf("\n");
 
 return out5;

}
 

/***********************************************************/
/***********************************************************/
double **sort(int k, double **data){
     double max=fabs(data[k][k]);
     int line=k,i,j;
     double t;
     for (i=k;i<N;i++) {
         if (fabs(data[i][k])>max) {max=fabs(data[i][k]);line=i;}
     }
     for (j=k;j<N+1;j++) {
         t=data[k][j];
         data[k][j]=data[line][j];
         data[line][j]=t;
     }
return data;
}

double cal(int t,int line,double *out,double **data){
       double s=0.0;
       int i;
       for (i=0;i<t;i++)
           s+=data[line][N-1-i]*out[N-1-i];
       return s;
}

double d_pow(double ival,int t){
       int i;
       double s=1.0;
       for (i=0;i<t;i++)
           s*=ival;
       return s;
}






  /**********************************************************************/  




#define IN_COUT 5     
#define COUT 5     






typedef struct {      
    int h;            
    double **v;   
    double **w;   
    double a;          
    double b;         
    int LoopCout;     
} bp_nn;

double fnet(double net) { 
    return 1/(1+exp(-net));
}

int InitBp(bp_nn *bp,int nb) { 
   
    
   
   /* printf("probability of Learning\n");
    scanf("%lf", &(*bp).a);    

    printf("Error parameters\n");
    scanf("%lf", &(*bp).b);
*/
(*bp).a=0.01;
(*bp).b=0.01;
printf("\n");
    printf("Maximum number of cycles-->");
    scanf("%d", &(*bp).LoopCout);
    printf("\n");
    printf("*******************************************\n");
    printf("Please wait a few minutes.\nAnd please believe that it is training!\n");
    printf("*******************************************\n");
    printf("\n");   
    int i, j;
    srand((unsigned)time(NULL));
    for (i = 0; i < IN_COUT; i++)
        for (j = 0; j < (*bp).h; j++)
            (*bp).v[i][j] = rand() / (double)(RAND_MAX/2)-1;   
            
    for (i = 0; i < (*bp).h; i++)
        for (j = 0; j < nb; j++)
            (*bp).w[i][j] = rand() / (double)(RAND_MAX/2)-1;   
   
    return 1;
}

int TrainBp(bp_nn *bp, double **x, int **y,int nb) {

    double f = (*bp).b;                      
    double a = (*bp).a;                      
    int h = (*bp).h;                         
    double v[IN_COUT][(*bp).h], w[(*bp).h][nb]; 
    double Ch_v[IN_COUT][(*bp).h], Ch_w[(*bp).h][nb]; 
    double ChgH[(*bp).h], ChgO[nb];         
    double O1[(*bp).h], O2[nb];             
    int LoopCout = (*bp).LoopCout;           
    int i, j, k, n;
    double temp;

    for (i = 0; i < IN_COUT; i++)            
        for (j = 0; j < h; j++)
            v[i][j] = (*bp).v[i][j];
    for (i = 0; i < h; i++)
        for (j = 0; j < nb; j++)
            w[i][j] = (*bp).w[i][j];
   
    double e = f + 1;
    for (n = 0; e > f && n < LoopCout; n++) { 
        e = 0;
        for (j = 0; j < nb; j++)
            ChgO[j] = 0;
        for (j = 0; j < h; j++)
            ChgH[j] = 0;
        for (j = 0; j < h; j++)         
            for (k = 0; k < nb; k++)
                Ch_w[j][k] = 0;
        for (j = 0; j < IN_COUT; j++)   
            for (k = 0; k < h; k++)
                Ch_v[j][k] = 0;
        for (i= 0; i < COUT*nb; i++) {
            for (k= 0; k < h; k++) {         
                temp = 0;
                for (j = 0; j < IN_COUT; j++)
                    temp = temp + x[i][j] * v[j][k];   
                O1[k] = fnet(temp);
            }
            for (k = 0; k < nb; k++) { 
                temp = 0;
                for (j = 0; j < h; j++)
                    temp = temp + O1[j] * w[j][k];
                O2[k] = fnet(temp);
            }
            for (j = 0; j < nb ; j++)   
                e = e + (y[i][j] - O2[j]) * (y[i][j] - O2[j]);
            for (j = 0; j < nb; j++)   
                ChgO[j] = O2[j] * (1 - O2[j]) * (y[i][j] - O2[j]);
            for (j = 0; j < h; j++)         
                for (k = 0; k < nb; k++)
                    Ch_w[j][k] += a * O1[j] * ChgO[k]; 
            for (j = 0; j < h; j++) {     
                temp = 0;
                for (k = 0; k < nb; k++)
                    temp = temp + w[j][k] * ChgO[k];
                ChgH[j] = temp * O1[j] * (1 - O1[j]);
            }
            for (j = 0; j < IN_COUT; j++)   
                for (k = 0; k < h; k++)
                    Ch_v[j][k] += a * x[i][j] * ChgH[k]; 
        }
        for (j = 0; j < h; j++)           
            for (k = 0; k < nb; k++)
                w[j][k] = w[j][k] + Ch_w[j][k];
        for (j = 0; j < IN_COUT; j++)     
            for (k = 0; k < h; k++)
                v[j][k] = v[j][k] + Ch_v[j][k];
        
    }
    /*printf("Total number of cycles%d\n", n);
    printf("Adjusted matrix of hidden layer\n");
    for (i = 0; i < IN_COUT; i++) {   
        for (j = 0; j < h; j++)
            printf("%f    ", v[i][j]);   
        printf("\n");
    }
    printf("Adjusted output layer matrix\n");
    for (i = 0; i < h; i++) {
        for (j = 0; j < nb; j++)
            printf("%f    ", w[i][j]);   
        printf("\n");
    }*/
    for (i = 0; i < IN_COUT; i++)             
        for (j = 0; j < h; j++)
            (*bp).v[i][j] = v[i][j];
    for (i = 0; i < h; i++)
        for (j = 0; j < nb; j++)
            (*bp).w[i][j] = w[i][j];
    printf("The end of BP network training\n");

          printf("Errors : %f\n", e);
          printf("number of cycles%d\n", n);
       
    return 1;
}

int UseBp(bp_nn *bp,int nb) {    
    float Input[IN_COUT];
    double *d_Input;
    double O1[(*bp).h];
    double O2[nb]; 
    int i, j;
    int iWidth, iHeight, iMaxValue,pixel;
    int *photo;
    double *d_photo;
    double avg_x;
    
    
    while (1) {           
              
        double temp;
        printf("\n");
        printf("------------------------------------\n");
        printf("Please enter a graphics of your face\n");
        printf("------------------------------------\n");
       
        photo=ReadPgm(&iWidth,&iHeight,&iMaxValue);
        pixel=iWidth*iHeight;
        d_photo=CreateONEDimensionalArray(pixel);
        d_Input=CreateONEDimensionalArray(IN_COUT);
        avg_x=0.0;             
        for(i=0;i<pixel;i++)
                        avg_x+=(double)photo[i]/pixel;
        for(i=0;i<pixel;i++) 
                        d_photo[i]=(double)(photo[i]-avg_x);
        avg_x=0.0; 
        
        d_Input=LSM(d_photo,pixel);
        double *LSM(double *read,int pixel);
        for (i = 0; i <IN_COUT; i++) Input[i]=d_Input[i];
        for (i = 0; i < (*bp).h; i++) {
            temp = 0.0;
            for (j = 0; j < IN_COUT; j++)
                temp += Input[j] * (*bp).v[j][i];
            O1[i] = fnet(temp);
        }
        for (i = 0; i < nb; i++) {
            temp = 0.0;
            for (j = 0; j < (*bp).h; j++)
                temp += O1[j] * (*bp).w[j][i];
            O2[i] = fnet(temp);
        }
        printf("probability   ");
        for (i = 0; i < nb; i++)
            printf("%.3f ", O2[i]);
        printf("\n");
    }
    return 1;
}

int BP(struct ID *mid,int nb)
{
    int i,j,k,t=0;
    
    
    double **x=d_CreateTwoDimensionalArray(COUT*nb,IN_COUT);
    int **y=CreateTwoDimensionalArray(COUT*nb,nb);
    
    for(i=0;i<COUT*nb;i++) for(j=0;j<nb;j++) y[i][j]=0;
    
    for(k=0;k<nb;k++){
                      for(i=0;i<COUT;i++){
                                    for(j=0;j<IN_COUT;j++) x[k*COUT+i][j]=mid[k].lsm[i][j];
                                      }
                      }
    
    
    for(j=0;j<COUT*nb;j++) {
                           t=j/COUT;
                           y[j][t]=1;
                           }
    
   
    
    /*for(i=0;i<5*nb;i++) {
                        for(k=0;k<nb;k++){
                                         
                                          printf("%d",y[i][k]);
                                          }
                       printf("\n");
                        }*/
                      
     
     
     
     bp_nn bp;

    bp.h=nb*COUT*20;
    
    bp.v=d_CreateTwoDimensionalArray(IN_COUT,bp.h);   
    bp.w=d_CreateTwoDimensionalArray(bp.h,nb);
    
   
    InitBp(&bp,nb);                    
    TrainBp(&bp, x, y, nb);             
    UseBp(&bp,nb);                    

    return 1;
} 
  

